local ladder = nil

function initLadder(_scn)
	--security check. don't allow resuming after tournament is over
	if variable.get(tournamentStage)==4 
	or variable.get(quitDuringMatch)==1 then variable.set(tournamentStage,0) end
	ladder = _scn
	print('INIT ladder')
	--resize ui elements
	local chooseTeam = actor.find('chooseTeam',_scn)
	local b = actor.find('okBtn',_scn)
	local ssize = aspectSize('xy',23)
	actor.set(b,'size',ssize .. ',' .. ssize)
	
	--create connectors between flags	
	local dist = actor.distance(actor.find('step1_flag1',_scn),
						        actor.find('step2_flag1',_scn))/2 .. ',8'
	local j = 1		
	for y=1,8 do --quarters
		createConnector('step1_flag'..y ,'step2_flag'..  div(y+1,2),'whiterect',dist )		
	end	
	for y=1,4 do --semi final
		createConnector('step2_flag'..y ,'step3_flag'..  div(y+1,2),'whiterect',dist )
		--clear flags
	end
	for y=1,2 do --finale
		createConnector('step3_flag'..y ,'step4_flag'..  div(y+1,2),'whiterect',dist )

	end
	--fill the flags depending on current tournament stage
	--first round, randomize teams
	local assigned = {}
	if variable.get(tournamentStage) == 0 then 		
		local flag2 = false
		for y=1,8 do
			local a = actor.find('step1_flag' .. y,_scn)
			while assigned[y]==nil do
				local r = math.random(teamsCount)
				local flag = false
				for k,v in pairs(assigned) do if v==teamNames[r] then flag = true end end
				if flag==false then table.insert(assigned, teamNames[r]) end
				if selectedTeam==teamNames[r] then flag2 = true end
			end			
			if not flag2 and y==8 then assigned[y] = selectedTeam end
			actor.set(a,'brush','flaga' .. assigned[y])		
			print('randomized team: ' .. assigned[y])
			--save the results in a persistent var
			variable.set(tournamentRound1,assigned[y],y-1)
		end
	end
	--second round, 
	if variable.get(tournamentStage) > 0 then 
		--load previous stage
		for y=1,8 do
			local f = variable.get(tournamentRound1,y-1)
			local a = actor.find('step1_flag' .. y,_scn)
			actor.set(a,'brush','flaga' .. f)
		end
		--randomize winners
		for y=0,3 do 
			local a = actor.find('step2_flag' .. y+1,_scn)
			local r = math.random(2)-1			
			local winner=variable.get(tournamentRound1,y*2+r)
			--if we are on this screen at this point then assume we won our match
			if variable.get(tournamentRound1,y*2)==selectedTeam or
			      variable.get(tournamentRound1,y*2+1)==selectedTeam  then
				  winner = selectedTeam
			end
			assigned[y+1] = winner
			actor.set(a,'brush','flaga' .. winner)
			--save the results in a persistent var
			variable.set(tournamentRound2,winner,y)
		end
		actor.set(chooseTeam,'text','Semi Final!')
	end
	--third round
	if variable.get(tournamentStage) > 1 then 
		--load previous stage
		for y=1,4 do
			local f = variable.get(tournamentRound2,y-1)
			local a = actor.find('step2_flag' .. y,_scn)
			actor.set(a,'brush','flaga' .. f)
		end
		--randomize winners
		for y=0,1 do 
			local a = actor.find('step3_flag' .. y+1,_scn)
			local r = math.random(2)-1			
			local winner=variable.get(tournamentRound2,y*2+r)
			--if we are on this screen at this point then assume we won our match
			if variable.get(tournamentRound2,y*2)==selectedTeam or
			      variable.get(tournamentRound2,y*2+1)==selectedTeam  then
				  winner = selectedTeam
			end
			assigned[y+1] = winner
			actor.set(a,'brush','flaga' .. winner)
			--save the results in a persistent var
			variable.set(tournamentRound3,winner,y)
		end
		actor.set(chooseTeam,'text','FINAL!!!')
	end
	
	if variable.get(tournamentStage) > 2 then 
		--if we're here then we won tournamet. 		
		local a = actor.find('step4_flag1',_scn)
		actor.set(a,'brush','flaga' .. selectedTeam)
		actor.set(chooseTeam,'text',"YOU'RE A CHAMPION!")
		--show some crowining anim & fanfare
		local size = actor.get(a,'size')
		resource.createFromString([[
		<icon brush="korona" position="]] .. size.x*0.4 ..',' .. size.y*-0.7 ..[[" 
			angle="6" layer="3" timeline="bounceIn" scale="0.001,0.001">
			<Timeline name="bounceIn" autoplay="1" >
				<Animation anim="bounceIn" target="scale" repeat="1" startAtTime="1.5" />
			</Timeline>	
		</icon>
		]],a)	
		--advance tournamentStage so player cant get here 
		--again and post hiscore if he closes the game now
		variable.set(tournamentStage,4)		
		submitScore()
	else
		--set kolor of opposing team		
		local k = findKey(assigned,selectedTeam)		
		print(selectedTeam  .. ' kontra')
		if k % 2 == 1 then k=k+1 else k = k - 1 end
		print('przeciwnicy: ' .. assigned[k])
		enemyTeam = assigned[k]
		k = (findKey(teamNames,assigned[k])*2)-1
		--primary colour would be k. secondary k+1
		kolorWroga2 = teamColors[k+1]
		kolorWroga1 = teamColors[k]
		print('kolor wroga1: ' ..  kolorWroga1)
		print('kolor wroga2: ' ..  kolorWroga2)
		
		k = (findKey(teamNames,selectedTeam)*2)-1
	
		kolorGracza1 = teamColors[k]
		kolorGracza2 = teamColors[k+1]
		print('kolor gracza1: ' ..  kolorGracza1)
		print('kolor gracza2: ' ..  kolorGracza2)
	end
	return 1
end

function createConnector(targeA,targeB,brus,siz)
	resource.create('actorconnector',{
		size=siz,
		brush=brus,
		targetA=targeA,
		targetB=targeB
	},ladder)
	return 1
end

function playLadderMatch(_btn)
	--switch scene to high scores if last match is won
	if variable.get(tournamentStage)==4 then
		freeMap(nil,'ladder','hiscores')
	else
		print('gonna play ladder match')
		--score needs to be saved in immediate vars too
		--so match can't bu quit in the middle
		--maybe add 'walkover' dialog to quit btn in match mode
		goleWrog = 0
		golePolska = 0
		czas = 90
		variable.set(quitDuringMatch,1)		
		scene.destroy(scene.getCurrent())
		sys.loadXoml('bieg.xml')
	end
	return 1
end
