--holds teams and results. index is name
teams= {}
--all teams names
teamNames = {
	'Poland',
	'Germany',
	'Italy',
	'Russia',
	'USA',
	'Brazil',
	'Saudi Arabia',	
	'UK',
	'Turkey',
	'France',
	'Mexico'}
for k,v in ipairs(teamNames ) do 
	teams[k] = {}
	teams[k].name = v
end

teamColors = {
	'255,255,255,255','200,0,0,255',--poland	
	'244,211,13,255','0,0,0,255',--germany
	'27,174,7,255', '219,33,0,255',--italy
	'227,14,18,255','227,14,18,255',--russia
	'255,255,255,255','4,41,144,255',--usa
	'8,47,160,255','0,174,53,255',--brazil
	'7,136,48,255','0,0,0,255',--saudi
	'252,13,17,255','13,42,252,255',--uk
	'255,0,0,255','255,255,255,255',--turkey
	'13,42,252,255','227,14,18,255',--france
	'219,33,0,255','27,174,7,255' --mexico
}
	
teamsCount = tableSize(teamNames)

function initTeamPicker(_scn)
	teams = {}
	--gracz se moze wybrac druzyne ze wszystkich dostepnych
	--reszta bedzie uzyta do wylosownania uczestnikow
	local row = 5
	local x,y=1,1
	local ssize = aspectSize('xy',20)
	for k,v in pairs(teamNames) do		
		local a = resource.create('icon',{
			brush="flaga"..v,
			size=ssize  .. ',' .. ssize*0.71,
			layer=1,
			scale='0.9,0.9',
			position=ssize*1.2*(x+1) - screenW2  .. ',' .. ssize*y*1.3 - screenH2*0.9 ,
			onTapped="tap"
		},_scn)
		resource.createFromString([[
			<Timeline name="selected" autoplay="0" timescale="1.3" >
				<Animation anim="selected" target="scale" />
			</Timeline>
			<Actions name="tap" >
				<Action Method="CallGlobalScript" p1="flagTap" />
			</Actions>
		]],a)
		actor.set(a,'timeline','selected')		
		x = x + 1
		if x>=row then
			y = y + 1
			x = 1
		end
		teams[k] = {}		
		teams[k].name = v
		teams[k].flagHandle = a
		teams[k].timeline = timeline.find('selected',a)
		local u = false
		if variable.get(variable.find(v .. 'o'))==1 then u = true end
		teams[k].unlocked = u
		--place a lock on flag if not unlocked. or a chain?:P
		if not u then			
			resource.create('icon',{brush='chain',size='-110,-20',position="0,10",
							aspectlock='x',tappable=0,name=v..'Chain'},a)
		end
	end	
	--select last played team	
	local v = variable.get(lastPlayedTeam)
	--first check if it's unlocked
	local team = findTeam(v)
	if team.unlocked==true then
		timeline.play(team.timeline)
		selectedTeam= v
	else --cheater?
		timeline.play(teams['Poland'].timeline)
		selectedTeam = 'Poland'
	end
	return 1
end

function flagTap(_flag)
	print('flag tap')
	local name = ''
	for k,v in pairs(teams) do
		if v.flagHandle==_flag then
			name=v.name
			break
		end
	end
	local team = findTeam(name)
	if not team.unlocked then 
		print('team ' .. name .. ' is locked')
		--scene.destroy(scene.getCurrent())
		--displayBuyDialog(name)
		local product = market.find(name)
		market.setPayload("le payload")
		market.purchase(product)
		if debugPurchases then itemBought(name) end
		return 0 
	end
	selectTeam(name)
	return 1
end

 --returns team by name
function findTeam(n)
	for k,v in pairs(teams) do 
		if string.lower(v.name)==string.lower(n) then 
			return v 
		end
	end 
	return nil
end

--unselects all teams and selects given one
function selectTeam(name)
	--stop timeline on other selected and restore its size
	for k,v in pairs(teams) do 
		timeline.stop(v.timeline)
		actor.set(v.flagHandle,'scale','0.9,0.9')
	end
	timeline.play(findTeam(name).timeline)
	variable.set(lastPlayedTeam,name)
	selectedTeam = name
	return 1
end

--item unlocked, refresh screen etc
function itemBought(item)
	print('itemBought: ' .. item)
	if (item=='saudiarabia') then item = 'saudi arabia' end
	--save item unlocked state
	variable.set(variable.find(item .. 'o'),1)
	local team = findTeam(item)
	team.unlocked = true
	--this can be executed from callback after game is launched
	local a = actor.find(item..'Chain',scene.getCurrent())
	if a~=nil then 
		--remove chain and select
		actor.destroy(a)
		selectTeam(team.name)
		--selectedTeam = team.name
		--timeline.play(team.timeline)
	end
	return 1
end