screenW = 0
screenH = 0
screenW2 = 0
screenH2 = 0
center = vec.new(0,0)

function rotatePoint(point, center, angle)
            angle = (angle ) * (math.pi/180); -- Convert to radians	  
            local rotatedX = math.cos(angle) * (point.x - center.x) - math.sin(angle) * (point.y-center.y) + center.x;
            local rotatedY = math.sin(angle) * (point.x - center.x) + math.cos(angle) * (point.y - center.y) + center.y;
            return rotatedX,rotatedY
 end
 
 function distance(x1,y1,x2,y2)
	local xd = x2-x1
	local yd = y2-y1
	return  math.sqrt(xd*xd + yd*yd)
end

function cloneActorsByTag(_tag,scena)
	print('clone player')
	tbl = actor.findTagged(_tag,scena)
	local offset = 100
	if tbl==nil then print('actor not found') else
		for k,v in pairs(tbl) do 
			local brush = actor.get(v,"brush")
			local size= actor.get(v,"size")
			local name = actor.get(v,"name")
			local pos = actor.get(v,"position")			
			local kolor = actor.get(v,"colour")	
			local tappable = actor.get(v,"tappable")
			local layer = actor.get(v,"layer")
			local a = actor.create('icon',scena,brush,size.x,size.y)			
			actor.set(a,'tag','wrog')			
			actor.set(a,'positionX',pos.x+offset)
			actor.set(a,'positiony',pos.y)
			actor.set(a,'colour',kolor)
			actor.set(a,'tappable',tappable)
			actor.set(a,'layer',layer)
			--clone joint
			--local j = joint.findJoint(v, name .. 'J')
			--clone children
			local ch =  actor.children(v)
			if ch~=nil then for kk,vv in pairs(ch) do				
				brush = actor.get(vv,"brush")
				size= actor.get(vv,"size")
				name = actor.get(vv,"name")
				pos = actor.get(vv,"position")
				kolor = actor.get(vv,"colour")	
				tappable = actor.get(vv,"tappable")
				layer = actor.get(vv,"layer")
				local b = actor.create('icon',a,brush,size.x,size.y)
				--actor.set(a,'linkedto',v)
				--actor.set(a,'tag','wrog')			
				actor.set(b,'position',pos)	
				actor.set(b,'colour',kolor)	
				actor.set(b,'tappable',tappable)
				actor.set(b,'layer',layer)
			end end
		end
	end
	return 1
end


--shalow table copy.  It only copies the top level value and its direct children;
function shallowCopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in pairs(orig) do
            copy[orig_key] = orig_value
        end
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

function deepCopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepCopy(orig_key)] = deepCopy(orig_value)
        end
        setmetatable(copy, deepCopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

function tableSize(tbl)
	local c = 0
	for k,v in pairs(tbl) do  c = c + 1 end
	return c	
end

--split string to table
function split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

--diference between two angles
function difAng( x, y)
	local arg = math.fmod(y-x, 360);
	if (arg < 0 )  then arg  = arg + 360 end
	if (arg > 180) then arg  = arg - 360 end
	return (-arg)
end

function findBrush(brush)
	brush = resource.find(tostring(brush),'brush')
	return 1
end

local touches = variable.find("touches")
function getClick(touchId)
	result = {}
	result.x = variable.get(touches,touchId) - (screenW/2)
	result.y = variable.get(touches,touchId+1) - (screenH/2)	
	--result.x = variable.get(touches,touchId) 
	--result.y = variable.get(touches,touchId+1)
	--print('click: ' .. result.x .. ' , ' .. result.y )
	--print(' screenw: ' .. screenW .. ' screenH: ' .. screenH)
	return result
end

function reorient(_scn)
	--screenW = variable.get(variable.find("system"),0)
	--screenH= variable.get(variable.find("system"),1)
	if _scn~=nil then
		screenW = scene.get(_scn,'canvasSize').x
		screenH= scene.get(_scn,'canvasSize').y
		screenW2 = screenW  / 2
		screenH2 = screenH / 2
	else
		print('reorient: needscene handle');
	end	
	return 1
end

--creates a movement animation for given actor from current pos 
--through array of points. callback string is function name that can be called on each animation end
function makeMovementAnim(_actor,lista,callback)
	print('makeMovementAnim::')
	local pos = actor.get(_actor,"position")
	local duration = 0
	local onEnd =""
	if callback~=nil then
		onEnd = [[ onEnd="callback" ]]
	end
	local startFrame = [[<Frame Value="]] .. pos.x .. ',' .. pos.y ..[[" Time="0" />]] .. '\n'
	local frames = ""
	local animName = "move" .. actor.get(_actor,"name")
	for k,v in ipairs(lista) do
		local time = distance(pos.x,pos.y,v.x,v.y) / 100
		print(time)
		duration = duration + time
		frames =  frames .. [[<Frame Value="]] .. v.x .. ',' .. v.y ..[[" Time="]] .. duration ..[[" />]].. '\n'
		pos = v
	end	
	local anim = 
	[[<Animation name="]].. animName .. [[" type="vec2" Duration = "]] .. duration .. [[">]] .. '\n' ..
	startFrame .. frames ..[[</Animation>
	<Timeline name="move" >
		<Animation anim="]] .. animName .. [[" target="position" repeat="1"]]  .. onEnd ..  [[/>
	</Timeline>
	]]
	
	if callback ~=nil then
		anim = anim ..[[
		<Actions name="callback" >
			<Action method="callGlobalScript" p1="]] .. callback .. [[" />
		</Actions>]]
	end
	print(anim)	
	resource.createFromString(anim,_actor)
	actor.set(_actor,"timeline","move")	
	local tm = timeline.find("move",_actor)
	timeline.restart(tm)
	timeline.play(tm)
	return 1
end

function followActor(_actor,target,walkSpeed)
	if actor.distance(_actor,target)<2 then 
		actor.set(_actor,"velocity","0,0")
		return 0 
	end
	local velocity = actor.get(target,"Velocity")
	local p1 = actor.get(target,"position")
         local p2 = actor.get(_actor,"position")
         local  x = p1.x - p2.x;
	local y = p1.y - p2.y;
	if (math.abs(x)< 0.01) then
		local oldX = x;
		x = x/math.abs(x) * walkSpeed;	
	end
	if x<0 then 
		x = math.max(x,-walkSpeed) 
	else  
		x = math.min(x,walkSpeed) 
	end	
	if(math.abs(y)< 0.01) then
		local oldY = y;
		y = y/math.abs(y) * walkSpeed;
	end	
	if y<0 then 
		y = math.max(y,-walkSpeed) 
	else 
		y = math.min(y,walkSpeed) 
	end
	actor.set(_actor,"velocity",x .. ',' .. y);
	return 1
end

function sign(x)
	return (x<0 and -1) or 1
end

function round(num, idp)
	local mult = 10^(idp or 0)
	return math.floor(num * mult + 0.5) / mult
end

function div(a,b)
	return  math.floor(a / b)
end

--returns screen percent size respecting sreen aspect ratio
function aspectSize(xy,percents)
	if xy=='x' then return screenW*(percents/100)
	elseif xy=='y' then return screenH*(percents/100)
	elseif xy=='xy' then 
		--use smaller one
		local z = screenH
		if screenH>screenW then z = screenW end
		return z*(percents/100)
	else 
		print('aspectSize:: valid params: x,y,xy')
		return nil
	end
end

function getVendor()	
	local v = variable.get(variable.find('system'),4)
	local sys='unknown system: ' .. v
	if v==2 then sys='android' end
	if v==0 or v==1 then sys='ios' end
	if v==6 then sys='windows' end
	print('getVendor: ' .. sys)
	return sys
end

function findKey( t, value )
	for k,v in pairs(t) do
		if v==value then return k end
	end
	return nil
end

function randomString(length)
       length = length or 1
       if length < 1 then return nil end
       local array = {}
            for i = 1, length do
                   array[i] = string.char(math.random(65, 90))
		if math.random(2)==1 then array[i] = string.lower(array[i]) end
      end
     return table.concat(array)
end